#ifndef __SEZNAM_H__
#define __SEZNAM_H__
#include "seznam_impl.h"
template<class T, template<class> class Aloktor = std::allocator, class Implementace = seznam_impl<T, Aloktor>>
class seznam
{
public:
	// Zveejnn typ hodnot
	using typ_hodnot = typename Implementace::typ_hodnot;
	// Konstruktory a destruktor
	seznam();
	seznam(std::initializer_list<T> si);
	seznam(const seznam& s) { implementace = new seznam_impl<T, Aloktor>(*s.implementace); }
	seznam(seznam&& s){}

	~seznam() { delete implementace; }

	void vlo_na_konec(T& co) { implementace->vlo_na_konec(co); }
	void vlo_na_konec(T&& co) { implementace->vlo_na_konec(std::move(co)); }

	void vpis() { implementace->vpis(); }
	void proho(seznam& s) { std::swap(implementace, s.implementace); }
	void proho(seznam&& s) { proho(s); }
	bool przdn() { return implementace->przdn(); }
private:
	Implementace* implementace;
};

template<class T, template<class> class Aloktor, class Implementace>
seznam<T, Aloktor, Implementace>::seznam()
{
	implementace = new Implementace();
}

template<class T, template<class> class Aloktor, class Implementace>
seznam<T, Aloktor, Implementace>::seznam(std::initializer_list<T> si)
{
	implementace = new Implementace(si);
}

#endif // __SEZNAM_H__